博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
(最短路和次短路) poj 1923
阅读量:5324 次
发布时间:2019-06-14

本文共 4526 字,大约阅读时间需要 15 分钟。

Sightseeing
Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 7601   Accepted: 2700

Description

Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the bus moves from one city S to another city F. On this way, the tourists in the bus can see the sights alongside the route travelled. Moreover, the bus makes a number of stops (zero or more) at some beautiful cities, where the tourists get out to see the local sights.

Different groups of tourists may have different preferences for the sights they want to see, and thus for the route to be taken from S to F. Therefore, Your Personal Holiday wants to offer its clients a choice from many different routes. As hotels have been booked in advance, the starting city S and the final city F, though, are fixed. Two routes from S to F are considered different if there is at least one road from a city A to a city B which is part of one route, but not of the other route.

There is a restriction on the routes that the tourists may choose from. To leave enough time for the sightseeing at the stops (and to avoid using too much fuel), the bus has to take a short route from S to F. It has to be either a route with minimal distance, or a route which is one distance unit longer than the minimal distance. Indeed, by allowing routes that are one distance unit longer, the tourists may have more choice than by restricting them to exactly the minimal routes. This enhances the impression of a personal holiday.

For example, for the above road map, there are two minimal routes from S = 1 to F = 5: 1 → 2 → 5 and 1 → 3 → 5, both of length 6. There is one route that is one distance unit longer: 1 → 3 → 4 → 5, of length 7.

Now, given a (partial) road map of the Benelux and two cities S and F, tour operator Your Personal Holiday likes to know how many different routes it can offer to its clients, under the above restriction on the route length.

Input

The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:

  • One line with two integers N and M, separated by a single space, with 2 ≤ N ≤ 1,000 and 1 ≤ M ≤ 10, 000: the number of cities and the number of roads in the road map.

  • M lines, each with three integers AB and L, separated by single spaces, with 1 ≤ AB ≤ NA ≠ B and 1 ≤ L ≤ 1,000, describing a road from city A to city B with length L.

    The roads are unidirectional. Hence, if there is a road from A to B, then there is not necessarily also a road from B to A. There may be different roads from a city A to a city B.

  • One line with two integers S and F, separated by a single space, with 1 ≤ SF ≤ N and S ≠ F: the starting city and the final city of the route.

    There will be at least one route from S to F.

Output

For every test case in the input file, the output should contain a single number, on a single line: the number of routes of minimal length or one distance unit longer. Test cases are such, that this number is at most 109 = 1,000,000,000.

Sample Input

25 81 2 31 3 21 4 52 3 12 5 33 4 23 5 44 5 31 55 62 3 13 2 13 1 104 5 25 2 75 2 74 1

Sample Output

32

Hint

The first test case above corresponds to the picture in the problem description.

Source

 

求最短路的条数和次短路中 与最短路仅仅相差一的条数

 

#include
#include
#include
#include
#include
#include
#include
#include
#include
#define INF 100000000using namespace std;vector
e[1005],w[1005];int n,m,s,t;int dist[1005][2],cnt[1005][2],vis[1005][2];int Dijkstra(){ int minn,flag,u; memset(dist,0x3f,sizeof(dist)); memset(vis,0,sizeof(vis)); memset(cnt,0,sizeof(cnt)); dist[s][0]=0; cnt[s][0]=1; for(int i=1;i<2*n;i++) { minn=INF; for(int j=1;j<=n;j++) { if(!vis[j][0]&&dist[j][0]
minn+ww) { dist[v][1]=dist[v][0]; cnt[v][1]=cnt[v][0]; dist[v][0]=minn+ww; cnt[v][0]=cnt[u][flag]; } else if(dist[v][0]==minn+ww) { cnt[v][0]+=cnt[u][flag]; } else if(dist[v][1]>minn+ww) { dist[v][1]=minn+ww; cnt[v][1]=cnt[u][flag]; } else if(dist[v][1]==minn+ww) { cnt[v][1]+=cnt[u][flag]; } } } if(dist[t][1]==dist[t][0]+1) cnt[t][0]+=cnt[t][1]; return cnt[t][0];}int main(){ int tt; scanf("%d",&tt); while(tt--) { scanf("%d%d",&n,&m); for(int i=1;i<=n;i++) e[i].clear(),w[i].clear(); for(int i=1;i<=m;i++) { int x,y,z; scanf("%d%d%d",&x,&y,&z); e[x].push_back(y); w[x].push_back(z); } scanf("%d%d",&s,&t); printf("%d\n",Dijkstra()); } return 0;}

  

转载于:https://www.cnblogs.com/water-full/p/4527795.html

你可能感兴趣的文章
详解C#委托,事件与回调函数(转)
查看>>
744. Find Smallest Letter Greater Than Target
查看>>
java实现二维码的生成.
查看>>
Android 发展思路
查看>>
Pythonic
查看>>
contentprovider的学习实例总结
查看>>
Sharepoint 自定义字段
查看>>
TQ2440之中断
查看>>
MySQL 触发器简单实例
查看>>
codeforces 712A. Memory and Crow
查看>>
Latex Undefined control sequence. ...\bm
查看>>
MySQL------报错Access denied for user 'root'@'localhost' (using password:NO)解决方法
查看>>
车牌识别LPR(三)-- LPR系统整体结构
查看>>
log4j异常:WARN No appenders could be found for logger
查看>>
新手村之顺序与分支
查看>>
4.秋招复习简单整理之java支持多继承吗?
查看>>
BZOJ2002: [Hnoi2010]Bounce 弹飞绵羊(LCT)
查看>>
Linux分区问题
查看>>
封装的ajax
查看>>
WP8 学习 Onnavigatedto和OnnavigatedFrom的区别
查看>>